package Peace::DAO::User;

use v5.30.0;

use strict;
use warnings;

use Params::ValidationCompiler qw/validation_for/;
use Types::Standard qw/HasMethods InstanceOf/;

{
    my $validator = validation_for(
        params => {
            dbh => { type => HasMethods ['selectall_arrayref'] },
        }
    );

    sub new {
        my $class  = shift;
        my %params = $validator->(@_);

        my $self = bless {}, $class;
        $self->{dbh} = $params{dbh};
        return $self;
    }
}

{
    my $validator = validation_for(
        params => {
            user => { type => InstanceOf['Peace::Model::User'] },
        }
    );
    sub create {
        my $self = shift;
        my %params = $validator->(@_);
        my $user = $params{user};
    }
}

sub _dbh {
    my $self = shift;
    return $self->{dbh};
}
1;
